*//	LZE DECODE ROUTINE
*//	Original Copyright (C)1995,2008 GORRY.
*//	Porting for 6800 by Kei Moroboshi 2020/Apr.
*	.6800

*If you can not use $0000-$0006 as zero page, Please chage following.
ZSTART		EQU	0
LZEPtr		EQU	ZSTART+0	;0,1
DISTANCE	EQU	ZSTART+2	;2,3
DECODEPtr	EQU	ZSTART+4	;4,5
COPYCOUNT	EQU	ZSTART+6	;6

*==============================================================================
*LZE data decoder
*Input:
*	X		LZE encoded data address(*)
*	A(H),B(L)	extracting address
*(*)lze.exe add 4 byte header as extracted size(big-endian).
*Therefore, you must set X as LZE data top + 4(skip the header).
*Broken:
*	A,B,X,P
*	Zero page 7 bytes.
*Example:
*	LDX	#LZESRC+4
*	LDAA	#HIGH DST
*	LDAB	#LOW DST
*	JSR	DECODE_LZE
*==============================================================================

DECODE_LZE:			;ENTRY
	STAA	DECODEPtr	;H
	STAB	DECODEPtr+1	;L
*	STX	LZEPtr
	CLRB
	STAB	COPYCOUNT	;CopyCount = 0;	6
	INCB			; BitCount=1

STORE:
	PSHA
	LDAA	0,X		; *(DECODEPtr++) = *(LZEPtr++);
	INX
	STX	LZEPtr
	LDX	DECODEPtr
	STAA	0,X
	INX
	STX	DECODEPtr
	LDX	LZEPtr
	PULA
MAINLP:
	DECB			;BitTest() {
	BNE	SKIP
	LDAA	0,X
	INX
	LDAB	#8
SKIP:	ASLA			;}

	BCS	STORE		;1:Store
				;0x:Copy
*Copy Byte Distance or Word Distance
	DECB			;BitTest() {
	BNE	SKIP0
	LDAA	0,X
	INX
	LDAB	#8		;
SKIP0:	ASLA			;}

	BCS	COPYWD		;01:Copy with Word Distance
				;00:Copy with Byte Distance

*Copy with Byte Distance
COPYBD:
	DECB			;BitTest() {
	BNE	SKIP00
	LDAA	0,X
	INX
	LDAB	#8
SKIP00:	ASLA			;}

	ROL	COPYCOUNT	;adc	CopyCount,CopyCount

	DECB			;BitTest() {
	BNE	SKIP01
	LDAA	0,X
	INX
	LDAB	#8
SKIP01:	ASLA			;}

	ROL	COPYCOUNT	;adc	CopyCount,CopyCount

	PSHB			;save B
	PSHA			;save A
	LDAB	0,X		;	DISTANCE = -256+((int)*(LZEPtr++));
	INX
	LDAA	#$FF		;-256
	ADDB	DECODEPtr+1	;CopyPtr=DISTANCE + DECODEPtr
	ADCA	DECODEPtr
	STAB	DISTANCE+1
	STAA	DISTANCE
	LDAB	COPYCOUNT
CPCNTP2:
	INCB			;inc	CopyCount
CPCNTP1:
	INCB			;inc	CopyCount

	STX	LZEPtr		;save X

LDIR:	LDX	DISTANCE	;copy
	LDAA	0,X
	INX
	STX	DISTANCE
	LDX	DECODEPtr
	STAA	0,X
	INX
	STX	DECODEPtr
	DECB
	BNE	LDIR
	STAB	COPYCOUNT
	PULA			;restore a
	PULB			;restore B
	LDX	LZEPtr		;restore X
	JMP	MAINLP

*Copy With WORD Distance
COPYWD:
	PSHB			;save B
	PSHA			;save A
	LDAA	0,X		;A=H:LoadDISTANCEW
	INX
	LDAB	0,X		;B=L
	INX
	STAB	COPYCOUNT	;mov	CopyCount,DISTANCE

	LSRA			;shr	DISTANCE,1
	RORB
	LSRA			;shr	DISTANCE,1
	RORB
	LSRA			;shr	DISTANCE,1
	RORB
	ORAA	#$E0		;or	DISTANCEH,0e0h

	ADDB	DECODEPtr+1	;CopyPtr=DISTANCE + DECODEPtr
	ADCA	DECODEPtr
	STAB	DISTANCE+1
	STAA	DISTANCE

	LDAB	COPYCOUNT
	ANDB	#7
	BNE	CPCNTP2
	LDAB	0,X
	INX
	TSTB
	BNE	CPCNTP1
DECODE_END:
	PULA
	PULB
	RTS
